<?php
add_action( 'add_meta_boxes', 'tchannel_meta_box_add' );
function tchannel_meta_box_add()
{
$options = get_option( 'tchannel_settings' );
$args = array('public'   => true);
$output = 'names'; // names or objects, note names is the default
$operator = 'and'; // 'and' or 'or'
$post_types = get_post_types( $args, $output, $operator ); 
foreach ( $post_types  as $post_type ) {
	if ($post_type == 'attachment' || $post_type == 'subscriber') {} else {
		$option = $options['tchannel_'.$post_type];
		if ($option == $post_type) {
		add_meta_box( 'tchannel-meta-box', __('Channeller', 'tchannel'), 'tchannel_meta_box_cb', $post_type, 'side', 'high' );
		}
	}
}
}

function tchannel_meta_box_cb( $post )
{
	$values = get_post_custom( $post->ID );
	$text = isset( $values['tchannel_text'] ) ? esc_attr( $values['tchannel_text'][0] ) : '';
	$selected = isset( $values['tchannel_select'] ) ? esc_attr( $values['tchannel_select'][0] ) : '';
	wp_nonce_field( 'tchannel_nonce', 'meta_box_nonces' );
	?>
	<p>
	<?php
	 printf(__( 'Send to Channels.', 'tchannel' )); 
	 echo '<br/>';
		$options = get_option( 'tchannel_settings' );
		$channelslist = explode("+", $options['tchannel_channels']);
		if(is_array($channelslist)) {
			foreach ($channelslist as $channel) {
			$channel_id = str_replace('@','',$channel);				
			?>
				<input type="checkbox" name="tchannel_check_<?php echo $channel_id; ?>" id="tchannel_check_<?php echo $channel_id; ?>" />
				<label for="tchannel_check_<?php echo $channel_id; ?>"><?php echo $channel_id;?></label><br/>
			<?php
			}
		}
		echo '<br/>';
		printf(__( 'Send to Groups', 'tchannel' )); 
		echo '<br/>';
		$groupslist = explode("+", $options['tchannel_groups']);
		if(is_array($groupslist)) {
			foreach ($groupslist as $group) {
			$grouper = str_replace('+','',$group);	
			$groupdata = explode("/", $grouper);
			$group_id = $groupdata[0];
			$group_name = $groupdata[1];
			?>
				<input type="checkbox" name="tchannel_checks_<?php echo $group_name; ?>" id="tchannel_checks_<?php echo $group_name; ?>" />
				<label for="tchannel_checks_<?php echo $group_name; ?>"><?php echo $group_name;?></label><br/>
			<?php
			}
		}
	?>
	</p>
	<p>
		<label for="tchannel_select"><?php printf(__( 'Message Text', 'tchannel' )); ?></label>
		<select name="tchannel_select" id="tchannel_select">
			<option value="url" <?php selected( $selected, 'url' ); ?>><?php printf(__( 'URL', 'tchannel' )); ?></option>
			<option value="shorturl" <?php selected( $selected, 'shorturl' ); ?>><?php printf(__( 'Short URL', 'tchannel' )); ?></option>
			<option value="customurl" <?php selected( $selected, 'customurl' ); ?>><?php printf(__( 'URL and Custom Message', 'tchannel' )); ?></option>
			<option value="shortcustomurl" <?php selected( $selected, 'shortcustomurl' ); ?>><?php printf(__( 'Short URL and Custom Message', 'tchannel' )); ?></option>
			<option value="customtext" <?php selected( $selected, 'customtext' ); ?>><?php printf(__( 'Custom Message', 'tchannel' )); ?></option>
		</select>
	</p>
	<p>
		<label for="tchannel_text" style="display: block;"><?php printf(__( 'Custom Message', 'tchannel' )); ?></label>
		<textarea style="width: 99%;"rows="3" name="tchannel_text" id="tchannel_text"><?php echo $text; ?></textarea>
	</p>
	<p>
		<label for="tchannel_image" style="display: block;"><?php printf(__( 'Custom Image', 'tchannel' )); ?></label>
		<textarea style="width: 99%;direction:ltr;"rows="3" name="tchannel_image" id="tchannel_image"><?php echo $image; ?></textarea>
		<span><?php printf(__( 'Please Enter Full Image URL on your site, Leave empty to not send images', 'tchannel' )); ?></span>
	</p>
	<?php	
}


add_action( 'save_post', 'tchannel_meta_box_save' );
function tchannel_meta_box_save( $post_id )
{
	// Bail if we're doing an auto save
	if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;
	
	// if our nonce isn't there, or we can't verify it, bail
	if( !isset( $_POST['meta_box_nonces'] ) || !wp_verify_nonce( $_POST['meta_box_nonces'], 'tchannel_nonce' ) ) return;
	
	// if our current user can't edit this post, bail
	if( !current_user_can( 'edit_post' ) ) return;
	
	// now we can actually save the data
	$allowed = array( 
		'a' => array( // on allow a tags
			'href' => array() // and those anchords can only have href attribute
		)
	);
	
	// Probably a good idea to make sure your data is set
	if( isset( $_POST['tchannel_text'] ) )
		update_post_meta( $post_id, 'tchannel_text', wp_kses( $_POST['tchannel_text'], $allowed ) );
	if( isset( $_POST['tchannel_image'] ) )
		update_post_meta( $post_id, 'tchannel_image', wp_kses( $_POST['tchannel_image'], $allowed ) );		
	if( isset( $_POST['tchannel_select'] ) )
		update_post_meta( $post_id, 'tchannel_select', esc_attr( $_POST['tchannel_select'] ) );
	
	$options = get_option( 'tchannel_settings' );
	$channelslist = explode("+", $options['tchannel_channels']);
		if(is_array($channelslist)) {
			foreach ($channelslist as $channel) {		
				$channel_id = str_replace('@','',$channel);	
				$channel_id = 'tchannel_check_'.$channel_id;	
				$chk = ( isset( $_POST[$channel_id] ) && $_POST[$channel_id] ) ? 'on' : 'off';
				if ($chk == 'on'){
							ch_sendmessage_publish ($post_id, $channel);
						}
		}
	}
	$groupslist = explode("+", $options['tchannel_groups']);
		if(is_array($groupslist)) {
			foreach ($groupslist as $group) {		
			$grouper = str_replace('+','',$group);	
			$groupdata = explode("/", $grouper);
			$group_id = $groupdata[0];
			$groupname = $groupdata[1];

				$groupname = 'tchannel_checks_'.$groupname;	
				$chk = ( isset( $_POST[$groupname] ) && $_POST[$groupname] ) ? 'on' : 'off';
				if ($chk == 'on'){
							ch_sendmessage_publish ($post_id, $group_id);
						}
		}
	}
}
?>